---
title: llarp::layers::flow::FlowHandshaker
summary: handles informing an observer at each step of obtaining a flow on the flow layer. 

---

# llarp::layers::flow::FlowHandshaker



handles informing an observer at each step of obtaining a flow on the flow layer. 


`#include <flow_auth.hpp>`

## Public Functions

|                | Name           |
| -------------- | -------------- |
| | **[FlowHandshaker](Classes/classllarp_1_1layers_1_1flow_1_1FlowHandshaker.md#function-flowhandshaker)**(std::function< void(std::optional< [FlowInfo](Classes/structllarp_1_1layers_1_1flow_1_1FlowInfo.md) >, std::string)> result_handler) |
| void | **[fail](Classes/classllarp_1_1layers_1_1flow_1_1FlowHandshaker.md#function-fail)**(std::string msg)<br>explicitly fail the handshake with an error message.  |
| void | **[ready](Classes/classllarp_1_1layers_1_1flow_1_1FlowHandshaker.md#function-ready)**([flow::FlowInfo](Classes/structllarp_1_1layers_1_1flow_1_1FlowInfo.md) flow_info)<br>explicitly inform that we are done with the handshake and we are ready to send.  |

## Public Attributes

|                | Name           |
| -------------- | -------------- |
| std::string | **[authcode](Classes/classllarp_1_1layers_1_1flow_1_1FlowHandshaker.md#variable-authcode)** <br>an optional static auth code  |

## Public Functions Documentation

### function FlowHandshaker

```cpp
FlowHandshaker(
    std::function< void(std::optional< FlowInfo >, std::string)> result_handler
)
```


### function fail

```cpp
void fail(
    std::string msg
)
```

explicitly fail the handshake with an error message. 

### function ready

```cpp
void ready(
    flow::FlowInfo flow_info
)
```

explicitly inform that we are done with the handshake and we are ready to send. 

## Public Attributes Documentation

### variable authcode

```cpp
std::string authcode;
```

an optional static auth code 

-------------------------------

Updated on 2023-02-08 at 22:18:31 +0000