---
title: llarp::layers::flow::FlowLayer
summary: flow layer's context that holds all the things in the flow layer 

---

# llarp::layers::flow::FlowLayer



flow layer's context that holds all the things in the flow layer 


`#include <flow_layer.hpp>`

## Public Functions

|                | Name           |
| -------------- | -------------- |
| | **[FlowLayer](Classes/classllarp_1_1layers_1_1flow_1_1FlowLayer.md#function-flowlayer)**([AbstractRouter](Classes/structllarp_1_1AbstractRouter.md) & ) |
| [FlowStats](Classes/structllarp_1_1layers_1_1flow_1_1FlowStats.md) | **[current_stats](Classes/classllarp_1_1layers_1_1flow_1_1FlowLayer.md#function-current-stats)**() const<br>get flow layer's informational stats at this moment in time.  |
| [FlowTag](Classes/structllarp_1_1layers_1_1flow_1_1FlowTag.md) & | **[best_flow_tag_to](Classes/classllarp_1_1layers_1_1flow_1_1FlowLayer.md#function-best-flow-tag-to)**(const [flow::FlowAddr](Classes/classllarp_1_1layers_1_1flow_1_1FlowAddr.md) & addr)<br>get the best flow tag to a remote address, autovivifies  |
| [FlowIdentity](Classes/classllarp_1_1layers_1_1flow_1_1FlowIdentity.md) & | **[get_source_for](Classes/classllarp_1_1layers_1_1flow_1_1FlowLayer.md#function-get-source-for)**(const [flow::FlowTag](Classes/structllarp_1_1layers_1_1flow_1_1FlowTag.md) & tag)<br>get the local identity for a flow tag, autovivifies  |
| void | **[offer_flow_traffic](Classes/classllarp_1_1layers_1_1flow_1_1FlowLayer.md#function-offer-flow-traffic)**([FlowTraffic](Classes/structllarp_1_1layers_1_1flow_1_1FlowTraffic.md) && traff)<br>synthetically inject flow layer traffic into the flow layer  |

## Public Functions Documentation

### function FlowLayer

```cpp
explicit FlowLayer(
    AbstractRouter & 
)
```


### function current_stats

```cpp
FlowStats current_stats() const
```

get flow layer's informational stats at this moment in time. 

### function best_flow_tag_to

```cpp
FlowTag & best_flow_tag_to(
    const flow::FlowAddr & addr
)
```

get the best flow tag to a remote address, autovivifies 

### function get_source_for

```cpp
FlowIdentity & get_source_for(
    const flow::FlowTag & tag
)
```

get the local identity for a flow tag, autovivifies 

### function offer_flow_traffic

```cpp
void offer_flow_traffic(
    FlowTraffic && traff
)
```

synthetically inject flow layer traffic into the flow layer 

-------------------------------

Updated on 2023-02-08 at 22:18:31 +0000