---
title: llarp::layers::platform::AddrMapper
summary: in charge of mapping flow addresses and platform addresses to each other 

---

# llarp::layers::platform::AddrMapper



in charge of mapping flow addresses and platform addresses to each other 


`#include <addr_mapper.hpp>`

## Public Functions

|                | Name           |
| -------------- | -------------- |
| [PlatformAddr](Classes/structllarp_1_1layers_1_1platform_1_1PlatformAddr.md) | **[next_free_addr](Classes/classllarp_1_1layers_1_1platform_1_1AddrMapper.md#function-next-free-addr)**() const<br>get the next unused address we can use for a remote  |
| void | **[put](Classes/classllarp_1_1layers_1_1platform_1_1AddrMapper.md#function-put)**([AddressMapping](Classes/structllarp_1_1layers_1_1platform_1_1AddressMapping.md) && )<br>unconditionally put an entry in  |
| std::optional< [AddressMapping](Classes/structllarp_1_1layers_1_1platform_1_1AddressMapping.md) > | **[get_addr_for_flow](Classes/classllarp_1_1layers_1_1platform_1_1AddrMapper.md#function-get-addr-for-flow)**(const [flow::FlowInfo](Classes/structllarp_1_1layers_1_1flow_1_1FlowInfo.md) & flow) const<br>get a platform for a flow if it exists  |
| bool | **[has_addr_for_flow](Classes/classllarp_1_1layers_1_1platform_1_1AddrMapper.md#function-has-addr-for-flow)**(const [flow::FlowInfo](Classes/structllarp_1_1layers_1_1flow_1_1FlowInfo.md) & flow) const<br>return true if we have an address for this flow info  |
| std::optional< [AddressMapping](Classes/structllarp_1_1layers_1_1platform_1_1AddressMapping.md) > | **[mapping_for](Classes/classllarp_1_1layers_1_1platform_1_1AddrMapper.md#function-mapping-for)**(const [PlatformAddr](Classes/structllarp_1_1layers_1_1platform_1_1PlatformAddr.md) & src, const [PlatformAddr](Classes/structllarp_1_1layers_1_1platform_1_1PlatformAddr.md) & dst) const<br>find a mapping that best matches src/dst address.  |
| template <typename Viewer_t \> <br>void | **[view_all_entries](Classes/classllarp_1_1layers_1_1platform_1_1AddrMapper.md#function-view-all-entries)**(Viewer_t && view) const |

## Public Functions Documentation

### function next_free_addr

```cpp
PlatformAddr next_free_addr() const
```

get the next unused address we can use for a remote 

### function put

```cpp
void put(
    AddressMapping && 
)
```

unconditionally put an entry in 

### function get_addr_for_flow

```cpp
std::optional< AddressMapping > get_addr_for_flow(
    const flow::FlowInfo & flow
) const
```

get a platform for a flow if it exists 

### function has_addr_for_flow

```cpp
inline bool has_addr_for_flow(
    const flow::FlowInfo & flow
) const
```

return true if we have an address for this flow info 

### function mapping_for

```cpp
std::optional< AddressMapping > mapping_for(
    const PlatformAddr & src,
    const PlatformAddr & dst
) const
```

find a mapping that best matches src/dst address. 

### function view_all_entries

```cpp
template <typename Viewer_t >
inline void view_all_entries(
    Viewer_t && view
) const
```


-------------------------------

Updated on 2023-02-08 at 22:18:31 +0000