---
title: llarp/layers/flow/flow_auth.hpp

---

# llarp/layers/flow/flow_auth.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |
| **[llarp::layers](Namespaces/namespacellarp_1_1layers.md)**  |
| **[llarp::layers::flow](Namespaces/namespacellarp_1_1layers_1_1flow.md)**  |

## Classes

|                | Name           |
| -------------- | -------------- |
| class | **[llarp::layers::flow::FlowHandshaker](Classes/classllarp_1_1layers_1_1flow_1_1FlowHandshaker.md)** <br>handles informing an observer at each step of obtaining a flow on the flow layer.  |




## Source code

```cpp
#pragma once

#include <optional>
#include <functional>
#include <string>

#include "flow_info.hpp"

namespace llarp::layers::flow
{

  class FlowHandshaker
  {
    std::function<void(std::optional<FlowInfo>, std::string)> _result_handler;
    // todo: add intermediate state hooks ?

   public:
    FlowHandshaker(std::function<void(std::optional<FlowInfo>, std::string)> result_handler);

    std::string authcode;

    void
    fail(std::string msg);

    void
    ready(flow::FlowInfo flow_info);
  };
}  // namespace llarp::layers::flow
```


-------------------------------

Updated on 2023-02-08 at 22:18:31 +0000
