---
title: llarp/layers/flow/flow_layer.hpp

---

# llarp/layers/flow/flow_layer.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |
| **[llarp::layers](Namespaces/namespacellarp_1_1layers.md)**  |
| **[llarp::layers::flow](Namespaces/namespacellarp_1_1layers_1_1flow.md)**  |

## Classes

|                | Name           |
| -------------- | -------------- |
| class | **[llarp::layers::flow::FlowLayer](Classes/classllarp_1_1layers_1_1flow_1_1FlowLayer.md)** <br>flow layer's context that holds all the things in the flow layer  |




## Source code

```cpp
#pragma once

#include <memory>

#include "flow_addr.hpp"
#include "flow_identity.hpp"
#include "flow_tag.hpp"
#include "flow_stats.hpp"
#include "flow_traffic.hpp"

namespace llarp
{
  class AbstractRouter;
}

namespace llarp::layers::flow
{

  class FlowLayer_pimpl;
  class FlowLayer
  {
    std::shared_ptr<FlowLayer_pimpl> _impl;
    FlowLayer(FlowLayer_pimpl*);

   public:
    explicit FlowLayer(AbstractRouter&);

    FlowStats
    current_stats() const;

    FlowTag&
    best_flow_tag_to(const flow::FlowAddr& addr);

    FlowIdentity&
    get_source_for(const flow::FlowTag& tag);

    void
    offer_flow_traffic(FlowTraffic&& traff);
  };
}  // namespace llarp::layers::flow
```


-------------------------------

Updated on 2023-02-08 at 22:18:31 +0000
