---
title: llarp/layers/platform/platform_layer.hpp

---

# llarp/layers/platform/platform_layer.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |
| **[llarp::layers](Namespaces/namespacellarp_1_1layers.md)**  |
| **[llarp::layers::platform](Namespaces/namespacellarp_1_1layers_1_1platform.md)**  |

## Classes

|                | Name           |
| -------------- | -------------- |
| class | **[llarp::layers::platform::PlatformLayer](Classes/classllarp_1_1layers_1_1platform_1_1PlatformLayer.md)** <br>owner of all platform layer components  |




## Source code

```cpp
#pragma once

#include <cstdint>
#include <memory>

#include <llarp/config/config.hpp>

#include "llarp/layers/flow/flow_layer.hpp"
#include "platform_driver.hpp"

namespace llarp
{
  // forward declare
  class AbstractRouter;
}  // namespace llarp

namespace llarp::layers::platform
{

  enum class PlatformKind : uint8_t
  {
    embedded,
    ip,
    // TODO: support this eventually
    // ethernet

  };

  class PlatformLayer_pimpl;

  class PlatformLayer
  {
    AbstractRouter& _router;
    flow::FlowLayer& _flow_layer;

   public:
    PlatformLayer(AbstractRouter&, flow::FlowLayer&);

    std::unique_ptr<PlatformDriver>
    make_platform_driver(Config config);
  };

}  // namespace llarp::layers::platform
```


-------------------------------

Updated on 2023-02-08 at 22:18:31 +0000
