---
title: llarp::layers::flow

---

# llarp::layers::flow



## Classes

|                | Name           |
| -------------- | -------------- |
| class | **[llarp::layers::flow::FlowLayer_pimpl](Classes/classllarp_1_1layers_1_1flow_1_1FlowLayer__pimpl.md)**  |
| class | **[llarp::layers::flow::FlowAddr](Classes/classllarp_1_1layers_1_1flow_1_1FlowAddr.md)** <br>a long form .snode or .loki address  |
| class | **[llarp::layers::flow::FlowHandshaker](Classes/classllarp_1_1layers_1_1flow_1_1FlowHandshaker.md)** <br>handles informing an observer at each step of obtaining a flow on the flow layer.  |
| struct | **[llarp::layers::flow::FlowIdentityPrivateKeys](Classes/structllarp_1_1layers_1_1flow_1_1FlowIdentityPrivateKeys.md)** <br>private keys used at the flow layer  |
| class | **[llarp::layers::flow::FlowIdentity](Classes/classllarp_1_1layers_1_1flow_1_1FlowIdentity.md)** <br>the local end of a one to one flow to a remote.  |
| struct | **[llarp::layers::flow::FlowInfo](Classes/structllarp_1_1layers_1_1flow_1_1FlowInfo.md)**  |
| class | **[llarp::layers::flow::FlowLayer](Classes/classllarp_1_1layers_1_1flow_1_1FlowLayer.md)** <br>flow layer's context that holds all the things in the flow layer  |
| class | **[llarp::layers::flow::FlowState](Classes/classllarp_1_1layers_1_1flow_1_1FlowState.md)** <br>internal state of a flow identity  |
| struct | **[llarp::layers::flow::FlowStats](Classes/structllarp_1_1layers_1_1flow_1_1FlowStats.md)**  |
| struct | **[llarp::layers::flow::FlowTag](Classes/structllarp_1_1layers_1_1flow_1_1FlowTag.md)** <br>a flow layer tag that indicates a distinct convo between us and other entity on the flow layer.  |
| struct | **[llarp::layers::flow::FlowTraffic](Classes/structllarp_1_1layers_1_1flow_1_1FlowTraffic.md)**  |

## Types

|                | Name           |
| -------------- | -------------- |
| enum class| **[FlowDataKind](Namespaces/namespacellarp_1_1layers_1_1flow.md#enum-flowdatakind)** { unknown, snapp_ip_unicast, exit_ip_unicast, auth, quic} |

## Attributes

|                | Name           |
| -------------- | -------------- |
| constexpr uint16_t | **[default_flow_mtu](Namespaces/namespacellarp_1_1layers_1_1flow.md#variable-default-flow-mtu)** <br>the mtu of plaintext data we transport via the flow layer.  |
| constexpr uint16_t | **[max_flow_mtu](Namespaces/namespacellarp_1_1layers_1_1flow.md#variable-max-flow-mtu)** <br>maximum mtu we can carry of the flow layer  |

## Types Documentation

### enum FlowDataKind

| Enumerator | Value | Description |
| ---------- | ----- | ----------- |
| unknown | |   |
| snapp_ip_unicast | |   |
| exit_ip_unicast | |   |
| auth | |   |
| quic | |   |






## Attributes Documentation

### variable default_flow_mtu

```cpp
static constexpr uint16_t default_flow_mtu = 1500;
```

the mtu of plaintext data we transport via the flow layer. 

### variable max_flow_mtu

```cpp
static constexpr uint16_t max_flow_mtu = 4096;
```

maximum mtu we can carry of the flow layer 




-------------------------------

Updated on 2023-02-08 at 22:18:31 +0000